Part Module/ja

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Part Module and the translation is 6% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎hrvatski • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎українська • ‎中文 • ‎中文(中国大陆)‎ • ‎中文(台灣)‎

Workbench Part.svg

FreeCADのCAD機能はOpenCasCadeカーネルをその基礎としています。FreeCADはパートモジュールによってOpenCasCadeオブジェクトとその機能へのアクセス・利用を行なっています。OpenCascadeはプロフェッショナル用のCADカーネルでその機能は3D形状操作、3D形状オブジェクトに特化しています。メッシュモジュール のオブジェクトと異なりパートオブジェクトはより複雑で、明確なブーリアン演算、変更履歴、パラメトリックな動作などのより高度な処理が可能です。

The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. This modelling paradigm is known as the constructive solid geometry (CSG) workflow, and it was the traditional methodology used in early CAD systems. On the other hand, the PartDesign Workbench provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations (feature editing), until the final object is obtained.

Part objects are more complex than mesh objects created with the Mesh Workbench, as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

Part example.jpg

Part Workbench relationships.svg

The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD


ツール

パートモジュールツールは全てパートモジュールを読み込んだ時点で表示されるPartメニューにあります。

Primitives

These are tools for creating primitive objects.

  • Part Box.png Box: Draws a box by specifying its dimensions
  • Part Cylinder.png Cylinder: Draws a cylinder by specifying its dimensions
  • Part Sphere.png Sphere: Draws a sphere by specifying its dimensions
  • Part Cone.png Cone: Draws a cone by specifying its dimensions
  • Part Torus.png Torus: Draws a torus (ring) by specifying its dimensions
  • Part CreatePrimitives.png CreatePrimitives: A tool to create various parametric geometric primitives
  • Part Shapebuilder.png Shapebuilder: A tool to create more complex shapes from various parametric geometric primitives

Modifying objects

These are tools for modifying existing objects. They will allow you to choose which object to modify.

  • Part Extrude.png Extrude: Extrudes planar faces of an object
  • Part Revolve.png Revolve: Creates a solid by revolving another object (not solid) around an axis
  • Part Mirror.png Mirror: Mirrors the selected object on a given mirror plane
  • Part Fillet.png Fillet: Fillets (rounds) edges of an object
  • Part Chamfer.png Chamfer: Chamfers edges of an object
  • Part RuledSurface.png Ruled Surface:
  • Part Loft.png Loft: Lofts from one profile to another
  • Part Sweep.png Sweep: Sweeps one or more profiles along a path
  • Part Thickness.png Thickness: Hollows out a solid, leaving openings next to select faces.
  • Part Booleans.png Booleans: Performs boolean operations on objects
  • Part Union.png Union: Fuses (unions) two objects
  • Part Common.png Common: Extracts the common (intersection) part of two objects
  • Part Cut.png Cut: Cuts (subtracts) one object from another

Other tools

Preferences

概念の説明

OpenCasCadeにおける用語では幾何プリミティブと(位相)シェイプは明確に区別されます。幾何プリミティブとは点、ライン、円、平面、それにB-スプライン曲線や曲面などのより複雑なタイプのものです。シェイプは頂点、エッジ、ワイヤー、面、ソリッド、それに他のシェイプの合成物です。幾何プリミティブは3Dシーン上に直接表示されることはありませんがシェイプの形状を作成するためには重要な役割を果たします。例えばエッジははラインまたは円の一部から作成されます。

つまり幾何プリミティブとは"形のない"構成単位であり、シェイプはその上に作られた実際の空間的な形状であると言えるでしょう。

その完全なリストを入手したい場合はOCCドキュメント(あるいはsourcearchive.com)を参照し、 Geom_*(幾何プリミティブの場合)とTopoDS_*(シェイプの場合)を検索してください。幾何オブジェクトとシェイプの違いについてより詳しい説明を読むことができます。残念なことに公式のOCCドキュメントはオンラインで利用することができず(アーカイブをダウンロードしなければなりません)、またそのほとんどがプログラマー向けのものでエンドユーザーに向けたものではないことに注意してください。ただしこれから始めるために必要な情報についてはここで十分確認することができるはずです。

実のところ幾何オブジェクトは大きく二つに分けることができます。カーブとサーフェスです。カーブ(ライン、円・・・)からはエッジを直接的に作成でき、サーフェス(平面、円筒・・・)からはフェイスを作成できます。例えば幾何プリミティブのラインは無限の長さを持ちます。つまり基底ベクトルと方向ベクトルによって定義されているのです。しかしそのシェイプ表現は始点と終点によって長さを制限されなければなりません。同様に直方体 -- ソリッド -- は六つの制限つき平面によって作成されます。

エッジやフェイスからはその対となる幾何プリミティブに戻ることもできます。

このようにしてシェイプから非常に複雑なパーツを作成したり、逆に複雑なシェイプからそれを構成するサブシェイプを全て抜き出したりすることが可能になっているのです。

In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.

A complete list of all primitives and shapes refer to the OCC documentation (Alternative: sourcearchive.com) and search for Geom_* (for geometric primitives) and TopoDS_* (for shapes). There you can also read more about the differences between them. Please note that the official OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counterpart.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

スクリプト処理

See also: Part scripting

パートモジュールで使用されている主なデータ構造はOpenCascadeのBRep(境界表現)データ型です。 現在ではパートモジュールのほとんど全ての機能とオブジェクト型がPythonスクリプトから利用可能になっています。これにはLineやCircle(あるいはArc)などの幾何プリミティブとVertexes、Edges、Wires、Faces、SolidsそしてCompoundsなどTopoShapesの全てが含まれます。これらの各オブジェクトにはいくつかの異なる作成方法があり、またオブジェクトの一部、特にTopoShapesではブーリアン演算の和集合/差集合/共通集合といったより高度な操作が可能になっています。パートモジュールの機能の詳細についてはFreeCADスクリプト処理の基礎ページを調べてください。

ライン要素を作成するにはPythonコンソールを開き、以下のように入力します:

import Part,PartGui 
doc=App.newDocument()  
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

上記のPythonスクリプトの例をステップごとに見ていきましょう:

import Part,PartGui
doc=App.newDocument()

パートモジュールを読み込み、新しいドキュメントを作成します。

l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

ラインは実際は線分なので始点と終点があります。

doc.addObject("Part::Feature","Line").Shape=l.toShape()

Partオブジェクト型をドキュメントに追加し、追加したオブジェクトの'Shape'プロパティに線分のシェイプ表現を代入します。ここで理解すべき重要な点は幾何プリミティブ(Part.Line)を使ってそこから位相シェイプを作成した(toShape()メソッド)ということです。ドキュメントに追加できるのはシェイプだけです。FreeCADでは幾何プリミティブはシェイプのための"作成用構造体"として使用されます。

doc.recompute()

ドキュメントを更新します。新しいパートオブジェクトの視覚的な表現を用意するための処理でもあります。

LineはPart.Line(point1,point2)という風にその始点と終点をコンストラクタで直接指定して作成することもできますし、ここで行ったようにデフォルトのラインを作成してあとでそのプロパティを設定することもできるということを憶えておいてください。

同じようにして円を作ることもできます:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

先ほどと同様、円(幾何プリミティブ)を使ってそのシェイプを作成しました。もちろんこの後、下記のような方法で作成した形状にアクセスすることができます:

s = f.Shape
e = s.Edges[0]
c = e.Curve
import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Let's go through the above python example step by step:

import Part,PartGui
doc=App.newDocument()

loads the Part module and creates a new document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line is actually a line segment, hence the start and endpoint.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

doc.recompute()

Updates the document. This also prepares the visual representation of the new part object.

Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

A circle can be created in a similar way:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

s = f.Shape
e = s.Edges[0]
c = e.Curve

ここではオブジェクトfのシェイプを取得した後、そのエッジのリストを取得しています。今回の場合、エッジは一つしかありません。円一つからシェイプ全体を作成しているためです。従ってEdgesリストの最初のアイテムだけ取得し、その後でそのCurve(曲線)を取得しています。Edgeは全てCurveを持ちます。これはエッジの元になっている幾何プリミティブです。

さらに詳しく知りたい場合は位相データのスクリプト処理ページを見て下さい。

チュートリアル